<?php

namespace Pim\Bundle\TransformBundle\Normalizer\Structured;

use Symfony\Component\Serializer\Normalizer\NormalizerInterface;

/**
 * Normalize a DateTime
 *
 * @author    Filips Alpe <filips@akeneo.com>
 * @copyright 2014 Akeneo SAS (http://www.akeneo.com)
 * @license   http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
 */
class DateTimeNormalizer implements NormalizerInterface
{
    /**
     * @var string[]
     */
    protected $supportedFormats = ['json', 'xml'];

    /**
     * {@inheritdoc}
     */
    public function normalize($object, $format = null, array $context = [])
    {
        $format = isset($context['format']) ? $context['format'] : 'Y-m-d';

        return $object->format($format);
    }

    /**
     * {@inheritdoc}
     */
    public function supportsNormalization($data, $format = null)
    {
        return $data instanceof \DateTime && in_array($format, $this->supportedFormats);
    }
}
